Index: /XIOS/trunk/src/config/field_attribute.conf
===================================================================
--- /XIOS/trunk/src/config/field_attribute.conf	(revision 886)
+++ /XIOS/trunk/src/config/field_attribute.conf	(revision 887)
@@ -18,4 +18,5 @@
 DECLARE_ATTRIBUTE(StdString, domain_ref)
 DECLARE_ATTRIBUTE(StdString, axis_ref)
+DECLARE_ATTRIBUTE(StdString, scalar_ref)
 DECLARE_ATTRIBUTE(StdString, grid_ref)
 DECLARE_ATTRIBUTE(StdString, field_ref)
Index: /XIOS/trunk/src/config/grid_attribute.conf
===================================================================
--- /XIOS/trunk/src/config/grid_attribute.conf	(revision 886)
+++ /XIOS/trunk/src/config/grid_attribute.conf	(revision 887)
@@ -12,3 +12,4 @@
 
 // An array contains order of axis and domains composing of the grid
-DECLARE_ARRAY_PRIVATE(bool, 1, axis_domain_order)
+// Value of element: domain 2, axis 1 and sclar 0
+DECLARE_ARRAY_PRIVATE(int, 1, axis_domain_order)
Index: /XIOS/trunk/src/config/node_type.conf
===================================================================
--- /XIOS/trunk/src/config/node_type.conf	(revision 886)
+++ /XIOS/trunk/src/config/node_type.conf	(revision 887)
@@ -55,4 +55,7 @@
 #endif //__XIOS_CGenerateRectilinearDomain__
 
+#ifdef __XIOS_CScalar__
+   DECLARE_NODE(Scalar, scalar)
+#endif //__XIOS_CScalar__
 
 #ifdef __XIOS_CContext__
Index: /XIOS/trunk/src/config/scalar_attribute.conf
===================================================================
--- /XIOS/trunk/src/config/scalar_attribute.conf	(revision 887)
+++ /XIOS/trunk/src/config/scalar_attribute.conf	(revision 887)
@@ -0,0 +1,10 @@
+DECLARE_ATTRIBUTE(StdString, name)
+DECLARE_ATTRIBUTE(StdString, standard_name)
+DECLARE_ATTRIBUTE(StdString, long_name)
+
+DECLARE_ATTRIBUTE(StdString, unit)
+
+/* LOCAL and GLOBAL*/
+DECLARE_ATTRIBUTE(double, value)
+
+DECLARE_ATTRIBUTE(StdString, scalar_ref)
Index: /XIOS/trunk/src/context_server.cpp
===================================================================
--- /XIOS/trunk/src/context_server.cpp	(revision 886)
+++ /XIOS/trunk/src/context_server.cpp	(revision 887)
@@ -184,5 +184,5 @@
          // The best way to properly solve this problem will be to use the event scheduler also in attached mode
          // for now just set up a MPI barrier
-         if (!CServer::eventScheduler) MPI_Barrier(intraComm) ; 
+         if (!CServer::eventScheduler) MPI_Barrier(intraComm) ;
 
          CTimer::get("Process events").resume();
@@ -238,4 +238,6 @@
     else if (event.classId==CAxis::GetType()) CAxis::dispatchEvent(event);
     else if (event.classId==CAxisGroup::GetType()) CAxisGroup::dispatchEvent(event);
+    else if (event.classId==CScalar::GetType()) CScalar::dispatchEvent(event);
+    else if (event.classId==CScalarGroup::GetType()) CScalarGroup::dispatchEvent(event);
     else if (event.classId==CGrid::GetType()) CGrid::dispatchEvent(event);
     else if (event.classId==CGridGroup::GetType()) CGridGroup::dispatchEvent(event);
Index: /XIOS/trunk/src/data_output.cpp
===================================================================
--- /XIOS/trunk/src/data_output.cpp	(revision 886)
+++ /XIOS/trunk/src/data_output.cpp	(revision 887)
@@ -16,5 +16,5 @@
       void CDataOutput::writeGrid(CGrid* grid, bool allowCompressedOutput /*= false*/)
       {
-        this->writeGrid(grid->getDomains(), grid->getAxis());
+        this->writeGrid(grid->getDomains(), grid->getAxis(), grid->getScalars());
 
         if (allowCompressedOutput)
@@ -58,4 +58,14 @@
         for (int i = 0; i < domSize; ++i) this->writeDomain_(domains[i]);
         for (int i = 0; i < aSize; ++i) this->writeAxis_(axis[i]);
+      }
+
+      void CDataOutput::writeGrid(std::vector<CDomain*> domains, std::vector<CAxis*> axis, std::vector<CScalar*> scalars)
+      {
+        int domSize = domains.size();
+        int aSize = axis.size();
+        int sSize = scalars.size();
+        for (int i = 0; i < domSize; ++i) this->writeDomain_(domains[i]);
+        for (int i = 0; i < aSize; ++i) this->writeAxis_(axis[i]);
+        for (int i = 0; i < sSize; ++i) this->writeScalar_(scalars[i]);
       }
 
Index: /XIOS/trunk/src/data_output.hpp
===================================================================
--- /XIOS/trunk/src/data_output.hpp	(revision 886)
+++ /XIOS/trunk/src/data_output.hpp	(revision 887)
@@ -44,4 +44,5 @@
             void writeGrid(CDomain* domain);
             void writeGrid(std::vector<CDomain*> domain, std::vector<CAxis*> axis);
+            void writeGrid(std::vector<CDomain*> domains, std::vector<CAxis*> axis, std::vector<CScalar*> scalars);
 
             virtual void writeFile_     (CFile*      file)   = 0;
@@ -53,4 +54,5 @@
             virtual void writeDomain_   (CDomain*    domain) = 0;
             virtual void writeAxis_     (CAxis*      axis)   = 0;
+            virtual void writeScalar_   (CScalar*    scalar) = 0;
             virtual void writeGridCompressed_(CGrid* grid)   = 0;
             virtual void writeTimeDimension_(void)           = 0;
Index: /XIOS/trunk/src/distribution.cpp
===================================================================
--- /XIOS/trunk/src/distribution.cpp	(revision 886)
+++ /XIOS/trunk/src/distribution.cpp	(revision 887)
@@ -21,9 +21,4 @@
 { /* Nothing to do */ }
 
-const CArray<size_t,1>& CDistribution::getGlobalIndex() const
-{
-  return globalIndex_;
-}
-
 int CDistribution::getDims() const
 {
Index: /XIOS/trunk/src/distribution.hpp
===================================================================
--- /XIOS/trunk/src/distribution.hpp	(revision 886)
+++ /XIOS/trunk/src/distribution.hpp	(revision 887)
@@ -32,8 +32,7 @@
     int getRank() const; //! Get rank of current process
 
-    //! Get global index
-    const CArray<size_t,1>& getGlobalIndex() const;
   protected:
-    virtual void createGlobalIndex() = 0;
+    virtual void createGlobalIndex() {};
+
   protected:
     CArray<size_t,1> globalIndex_;
Index: /XIOS/trunk/src/distribution_client.cpp
===================================================================
--- /XIOS/trunk/src/distribution_client.cpp	(revision 886)
+++ /XIOS/trunk/src/distribution_client.cpp	(revision 887)
@@ -56,13 +56,8 @@
   std::vector<CDomain*> domList = grid->getDomains();
   std::vector<CAxis*> axisList = grid->getAxis();
-  CArray<bool,1> axisDomainOrder = grid->axis_domain_order;
-
-  std::vector<CDomain*>::iterator itbDom, iteDom, itDom;
-  std::vector<CAxis*>::iterator itbAxis, iteAxis, itAxis;
-
-  itbDom  = itDom  = domList.begin();  iteDom  = domList.end();
-  itbAxis = itAxis = axisList.begin(); iteAxis = axisList.end();
-
-  readDistributionInfo(domList, axisList, axisDomainOrder);
+  std::vector<CScalar*> scalarList = grid->getScalars();
+  CArray<int,1> axisDomainOrder = grid->axis_domain_order;
+
+  readDistributionInfo(domList, axisList, scalarList, axisDomainOrder);
 
   // Then check mask of grid
@@ -92,10 +87,12 @@
   \param [in] domList List of domains of grid
   \param [in] axisList List of axis of grid
-  \param [in] axisDomainOrder order of axis and domain inside a grid. True if domain, false if axis
+  \param [in] scalarList List of scalar of grid
+  \param [in] axisDomainOrder order of axis and domain inside a grid. 2 if domain, 1 if axis and zero if scalar
 //  \param [in] gridMask Mask of grid, for now, keep it 3 dimension, but it needs changing
 */
 void CDistributionClient::readDistributionInfo(const std::vector<CDomain*>& domList,
                                                const std::vector<CAxis*>& axisList,
-                                               const CArray<bool,1>& axisDomainOrder)
+                                               const std::vector<CScalar*>& scalarList,
+                                               const CArray<int,1>& axisDomainOrder)
 {
   domainNum_ = domList.size();
@@ -129,5 +126,5 @@
   {
     indexMap_[i] = idx;
-    if (true == axisDomainOrder(i))
+    if (2 == axisDomainOrder(i))
     {
       ++(this->dims_);
@@ -155,5 +152,5 @@
 
   // A trick to determine position of each domain in domainList
-  int domIndex = 0, axisIndex = 0;
+  int domIndex = 0, axisIndex = 0, scalarIndex = 0;
   idx = 0;
 
@@ -172,10 +169,10 @@
   for (idx = 0; idx < numElement_; ++idx)
   {
-    bool isDomain = axisDomainOrder(idx);
+    int eleDim = axisDomainOrder(idx);
     elementNLocal_[idx] = localSize;
     elementNGlobal_[idx] = globalSize;
 
     // If this is a domain
-    if (isDomain)
+    if (2 == eleDim)
     {
       // On the j axis
@@ -188,6 +185,8 @@
 
       dataBegin_.at(indexMap_[idx]+1) = domList[domIndex]->data_jbegin.getValue(); //(2 == domList[domIndex]->data_dim) ? domList[domIndex]->data_jbegin.getValue() : -1;
-      dataIndex_.at(indexMap_[idx]+1) = &(domList[domIndex]->data_j_index);
-      infoIndex_.at(indexMap_[idx]+1) = &(domList[domIndex]->j_index);
+//      dataIndex_.at(indexMap_[idx]+1) = &(domList[domIndex]->data_j_index);
+//      infoIndex_.at(indexMap_[idx]+1) = &(domList[domIndex]->j_index);
+      dataIndex_.at(indexMap_[idx]+1).reference(domList[domIndex]->data_j_index);
+      infoIndex_.at(indexMap_[idx]+1).reference(domList[domIndex]->j_index);
 
       // On the i axis
@@ -200,6 +199,8 @@
 
       dataBegin_.at(indexMap_[idx]) = domList[domIndex]->data_ibegin.getValue();
-      dataIndex_.at(indexMap_[idx]) = &(domList[domIndex]->data_i_index);
-      infoIndex_.at(indexMap_[idx]) = &(domList[domIndex]->i_index);
+//      dataIndex_.at(indexMap_[idx]) = &(domList[domIndex]->data_i_index);
+//      infoIndex_.at(indexMap_[idx]) = &(domList[domIndex]->i_index);
+      dataIndex_.at(indexMap_[idx]).reference(domList[domIndex]->data_i_index);
+      infoIndex_.at(indexMap_[idx]).reference(domList[domIndex]->i_index);
 
       dataNIndex_.at(idx) = domList[domIndex]->data_i_index.numElements();
@@ -212,5 +213,5 @@
       ++domIndex;
     }
-    else // So it's an axis
+    else if (1 == eleDim)// So it's an axis
     {
       nLocal_.at(indexMap_[idx]) = axisList[axisIndex]->n.getValue();
@@ -222,6 +223,8 @@
 
       dataBegin_.at(indexMap_[idx]) = axisList[axisIndex]->data_begin.getValue();
-      dataIndex_.at(indexMap_[idx]) = &(axisList[axisIndex]->data_index);
-      infoIndex_.at(indexMap_[idx]) = &(axisList[axisIndex]->index);
+//      dataIndex_.at(indexMap_[idx]) = &(axisList[axisIndex]->data_index);
+//      infoIndex_.at(indexMap_[idx]) = &(axisList[axisIndex]->index);
+      dataIndex_.at(indexMap_[idx]).reference(axisList[axisIndex]->data_index);
+      infoIndex_.at(indexMap_[idx]).reference(axisList[axisIndex]->index);
       dataNIndex_.at(idx) = axisList[axisIndex]->data_index.numElements();
       dataDims_.at(idx) = 1;
@@ -233,4 +236,26 @@
 
       ++axisIndex;
+    }
+    else // scalar
+    {
+      nLocal_.at(indexMap_[idx]) = 1;
+      nGlob_.at(indexMap_[idx]) = 1;
+      nBeginLocal_.at(indexMap_[idx]) = 0;
+      nBeginGlobal_.at(indexMap_[idx]) = 1;
+      nZoomBegin_.at((indexMap_[idx])) = 0;
+      nZoomEnd_.at((indexMap_[idx])) = 0;
+
+      dataBegin_.at(indexMap_[idx]) = 0;
+      dataIndex_.at(indexMap_[idx]).resize(1); dataIndex_.at(indexMap_[idx])(0) = 0;
+      infoIndex_.at(indexMap_[idx]).resize(1); infoIndex_.at(indexMap_[idx])(0) = 0;
+      dataNIndex_.at(idx) = 1;
+      dataDims_.at(idx) = 1;
+
+      isDataDistributed_ |= false;
+
+      localSize *= nLocal_.at(indexMap_[idx]);
+      globalSize *= nGlob_.at(indexMap_[idx]);
+
+      ++scalarIndex;
     }
   }
@@ -248,5 +273,5 @@
   for (int i = 0; i < axisDomainOrder_.numElements(); ++i)
   {
-    if (axisDomainOrder_(i))
+    if (2 == axisDomainOrder_(i))
     {
       elementIndexData_[i].resize(dataNIndex_[i]);
@@ -255,5 +280,5 @@
       for (int j = 0; j < dataNIndex_[i]; ++j)
       {
-        iIdx = getDomainIndex((*dataIndex_[indexMap_[i]])(j), (*dataIndex_[indexMap_[i]+1])(j),
+        iIdx = getDomainIndex((dataIndex_[indexMap_[i]])(j), (dataIndex_[indexMap_[i]+1])(j),
                               dataBegin_[indexMap_[i]], dataBegin_[indexMap_[i]+1],
                               dataDims_[i], nLocal_[indexMap_[i]], jIdx);
@@ -281,13 +306,13 @@
         if (tmpIndexElementData(j))
         {
-          iIdx = getDomainIndex((*dataIndex_[indexMap_[i]])(j), (*dataIndex_[indexMap_[i]+1])(j),
+          iIdx = getDomainIndex((dataIndex_[indexMap_[i]])(j), (dataIndex_[indexMap_[i]+1])(j),
                                 dataBegin_[indexMap_[i]], dataBegin_[indexMap_[i]+1],
                                 dataDims_[i], nLocal_[indexMap_[i]], jIdx);
           localIndex = tmpLocalElementIndex(count) = iIdx + jIdx * nLocal_[indexMap_[i]];
-          tmpGlobalElementIndex(count) = (*infoIndex_[indexMap_[i]])(localIndex) + ((*infoIndex_[indexMap_[i]+1])(localIndex))*nGlob_[indexMap_[i]];
-          if ((((*infoIndex_[indexMap_[i]])(localIndex)) <= nZoomEnd_[indexMap_[i]])
-             && (nZoomBegin_[indexMap_[i]] <= ((*infoIndex_[indexMap_[i]])(localIndex)))
-             && (((*infoIndex_[indexMap_[i]+1])(localIndex)) <= nZoomEnd_[indexMap_[i]+1])
-             && (nZoomBegin_[indexMap_[i]+1] <= ((*infoIndex_[indexMap_[i]+1])(localIndex))))
+          tmpGlobalElementIndex(count) = (infoIndex_[indexMap_[i]])(localIndex) + ((infoIndex_[indexMap_[i]+1])(localIndex))*nGlob_[indexMap_[i]];
+          if ((((infoIndex_[indexMap_[i]])(localIndex)) <= nZoomEnd_[indexMap_[i]])
+             && (nZoomBegin_[indexMap_[i]] <= ((infoIndex_[indexMap_[i]])(localIndex)))
+             && (((infoIndex_[indexMap_[i]+1])(localIndex)) <= nZoomEnd_[indexMap_[i]+1])
+             && (nZoomBegin_[indexMap_[i]+1] <= ((infoIndex_[indexMap_[i]+1])(localIndex))))
           {
             tmpZoomMaskElement(count) = true;
@@ -309,5 +334,5 @@
   for (int i = 0; i < axisDomainOrder_.numElements(); ++i)
   {
-    if (!axisDomainOrder_(i))
+    if (1 == axisDomainOrder_(i))
     {
       elementIndexData_[i].resize(dataNIndex_[i]);
@@ -316,5 +341,5 @@
       for (int j = 0; j < dataNIndex_[i]; ++j)
       {
-        iIdx = getAxisIndex((*dataIndex_[indexMap_[i]])(j), dataBegin_[indexMap_[i]], nLocal_[indexMap_[i]]);
+        iIdx = getAxisIndex((dataIndex_[indexMap_[i]])(j), dataBegin_[indexMap_[i]], nLocal_[indexMap_[i]]);
         if ((iIdx >= nBeginLocal_[indexMap_[i]]) &&
            (iIdx < nLocal_[indexMap_[i]]) && (axisMasks_[idxAxis](iIdx)))
@@ -338,8 +363,8 @@
         if (tmpIndexElementData(j))
         {
-          iIdx = tmpLocalElementIndex(count) = getAxisIndex((*dataIndex_[indexMap_[i]])(j), dataBegin_[indexMap_[i]], nLocal_[indexMap_[i]]);
-          tmpGlobalElementIndex(count) = (*infoIndex_[indexMap_[i]])(iIdx);
-          if ((((*infoIndex_[indexMap_[i]])(iIdx)) <= nZoomEnd_[indexMap_[i]])
-             && (nZoomBegin_[indexMap_[i]] <= ((*infoIndex_[indexMap_[i]])(iIdx))))
+          iIdx = tmpLocalElementIndex(count) = getAxisIndex((dataIndex_[indexMap_[i]])(j), dataBegin_[indexMap_[i]], nLocal_[indexMap_[i]]);
+          tmpGlobalElementIndex(count) = (infoIndex_[indexMap_[i]])(iIdx);
+          if ((((infoIndex_[indexMap_[i]])(iIdx)) <= nZoomEnd_[indexMap_[i]])
+             && (nZoomBegin_[indexMap_[i]] <= ((infoIndex_[indexMap_[i]])(iIdx))))
           {
             tmpZoomMaskElement(count) = true;
@@ -349,4 +374,28 @@
       }
       ++idxAxis;
+    }
+  }
+}
+
+/*!
+  Create local index of scalar.
+*/
+void CDistributionClient::createLocalScalarDataIndex()
+{
+  int idxAxis = 0;
+  for (int i = 0; i < axisDomainOrder_.numElements(); ++i)
+  {
+    if (0 == axisDomainOrder_(i))
+    {
+      elementIndexData_[i].resize(dataNIndex_[i]);
+      elementIndexData_[i] = true;
+      int count = 1;
+
+      elementLocalIndex_[i].resize(count);
+      elementLocalIndex_[i] = 0;
+      elementGlobalIndex_[i].resize(count);
+      elementGlobalIndex_[i] = 0;
+      elementZoomMask_[i].resize(count);
+      elementZoomMask_[i] = true;
     }
   }
@@ -530,53 +579,52 @@
 void CDistributionClient::createGlobalIndex()
 {
-  size_t ssize = 1, idx = 0;
-  for (int i = 0; i < this->dims_; ++i)
-  ssize *= nLocal_[i];
-
-  this->globalIndex_.resize(ssize);
-  std::vector<int> idxLoop(this->numElement_,0);
-  int innnerLoopSize = (*infoIndex_[0]).numElements();
-  while (idx < ssize)
-  {
-    for (int i = 0; i < this->numElement_; ++i)
-    {
-      if (idxLoop[i] == (*infoIndex_[indexMap_[i]]).numElements())
-      {
-        idxLoop[i] = 0;
-        ++idxLoop[i+1];
-      }
-    }
-
-    for (int i = 0; i < innnerLoopSize; ++i)
-    {
-      size_t globalIndex = (*infoIndex_[0])(idxLoop[0]);
-      size_t mulDim = 1;
-      for (int idxElement = 0; idxElement < this->numElement_; ++idxElement)
-      {
-        if (axisDomainOrder_(idxElement))
-        {
-          int jb = (0 == idxElement) ? 1 : 0;
-          for (int j = jb; j <= 1; ++j)
-          {
-            mulDim *= nGlob_[indexMap_[idxElement]+j-1];
-            globalIndex += ((*infoIndex_[indexMap_[idxElement]+j])(idxLoop[idxElement]))*mulDim;
-          }
-        }
-        else
-        {
-          if (0 != idxElement)
-          {
-            mulDim *= nGlob_[indexMap_[idxElement]-1];
-            globalIndex += ((*infoIndex_[indexMap_[idxElement]])(idxLoop[idxElement]))*mulDim;
-          }
-        }
-      }
-
-      this->globalIndex_(idx) = globalIndex;
-      ++idxLoop[0];
-      ++idx;
-    }
-  }
-
+//  size_t ssize = 1, idx = 0;
+//  for (int i = 0; i < this->dims_; ++i)
+//  ssize *= nLocal_[i];
+//
+//  this->globalIndex_.resize(ssize);
+//  std::vector<int> idxLoop(this->numElement_,0);
+//  int innnerLoopSize = (infoIndex_[0]).numElements();
+//  while (idx < ssize)
+//  {
+//    for (int i = 0; i < this->numElement_; ++i)
+////    {
+//      if (idxLoop[i] == (infoIndex_[indexMap_[i]]).numElements())
+//      {
+//        idxLoop[i] = 0;
+//        ++idxLoop[i+1];
+//      }
+//    }
+//
+//    for (int i = 0; i < innnerLoopSize; ++i)
+//    {
+//      size_t globalIndex = (infoIndex_[0])(idxLoop[0]);
+//      size_t mulDim = 1;
+//      for (int idxElement = 0; idxElement < this->numElement_; ++idxElement)
+//      {
+//        if (axisDomainOrder_(idxElement))
+//        {
+//          int jb = (0 == idxElement) ? 1 : 0;
+//          for (int j = jb; j <= 1; ++j)
+//          {
+//            mulDim *= nGlob_[indexMap_[idxElement]+j-1];
+//            globalIndex += ((infoIndex_[indexMap_[idxElement]+j])(idxLoop[idxElement]))*mulDim;
+//          }
+//        }
+//        else
+//        {
+//          if (0 != idxElement)
+//          {
+//            mulDim *= nGlob_[indexMap_[idxElement]-1];
+//            globalIndex += ((infoIndex_[indexMap_[idxElement]])(idxLoop[idxElement]))*mulDim;
+//          }
+//        }
+//      }
+//
+//      this->globalIndex_(idx) = globalIndex;
+//      ++idxLoop[0];
+//      ++idx;
+//    }
+//  }
 }
 
Index: /XIOS/trunk/src/distribution_client.hpp
===================================================================
--- /XIOS/trunk/src/distribution_client.hpp	(revision 886)
+++ /XIOS/trunk/src/distribution_client.hpp	(revision 887)
@@ -21,4 +21,5 @@
 class CDomain;
 class CAxis;
+class CScalar;
 
 /*!
@@ -61,5 +62,6 @@
     void readDistributionInfo(const std::vector<CDomain*>& domList,
                               const std::vector<CAxis*>& axisList,
-                              const CArray<bool,1>& axisDomainOrder);
+                              const std::vector<CScalar*>& scalarList,
+                              const CArray<int,1>& axisDomainOrder);
   private:
     //! Create local index of a domain
@@ -68,4 +70,7 @@
     //! Create local index of an axis
     void createLocalAxisDataIndex();
+
+    //! Create local index of a scalar
+    void createLocalScalarDataIndex();
 
     template<int N>
@@ -82,5 +87,5 @@
      * A grid composed of 1 domain and 1 axis has 2 elements */
     int numElement_;
-    CArray<bool,1> axisDomainOrder_; //!< Order of axis and domain of a grid
+    CArray<int,1> axisDomainOrder_; //!< Order of axis and domain of a grid
 
     std::vector<int> nLocal_; //!< Local size of each dimension (ni, nj, etc, ...)
@@ -95,6 +100,6 @@
     std::vector<int> dataDims_; //!< Data_dim, domain can have data_dim == 1 or 2
     std::vector<int> dataBegin_; //!< Data begin (data_ibegin, data_jbegin, etc)
-    std::vector<CArray<int,1>* > dataIndex_; //!< Data index
-    std::vector<CArray<int,1>* > infoIndex_; //!< i_index, j_index
+    std::vector<CArray<int,1> > dataIndex_; //!< Data index
+    std::vector<CArray<int,1> > infoIndex_; //!< i_index, j_index
 
     std::vector<CArray<bool,1> > domainMasks_; //!< Domain mask
Index: /XIOS/trunk/src/group_factory_decl.cpp
===================================================================
--- /XIOS/trunk/src/group_factory_decl.cpp	(revision 886)
+++ /XIOS/trunk/src/group_factory_decl.cpp	(revision 887)
@@ -31,3 +31,4 @@
   macro(CInterpolateDomainGroup)
   macro(CGenerateRectilinearDomainGroup)
+  macro(CScalarGroup)
 }
Index: /XIOS/trunk/src/group_template_decl.cpp
===================================================================
--- /XIOS/trunk/src/group_template_decl.cpp	(revision 886)
+++ /XIOS/trunk/src/group_template_decl.cpp	(revision 887)
@@ -20,4 +20,5 @@
   macro(InterpolateDomain)
   macro(GenerateRectilinearDomain)
+  macro(Scalar)
 
 }
Index: /XIOS/trunk/src/io/nc4_data_input.cpp
===================================================================
--- /XIOS/trunk/src/io/nc4_data_input.cpp	(revision 886)
+++ /XIOS/trunk/src/io/nc4_data_input.cpp	(revision 887)
@@ -82,5 +82,5 @@
         std::vector<StdSize> start, count;
 
-        CArray<bool,1> axisDomainOrder = grid->axis_domain_order;
+        CArray<int,1> axisDomainOrder = grid->axis_domain_order;
         std::vector<StdString> domainList = grid->getDomainList();
         std::vector<StdString> axisList   = grid->getAxisList();
@@ -94,5 +94,5 @@
         for (int i = numElement - 1; i >= 0; --i)
         {
-          if (axisDomainOrder(i))
+          if (2 == axisDomainOrder(i))
           {
             CDomain* domain = CDomain::get(domainList[idxDomain]);
@@ -108,5 +108,5 @@
             --idxDomain;
           }
-          else
+          else if (1 == axisDomainOrder(i))
           {
             start.push_back(nZoomBeginServer[idx] - nZoomBeginGlobal[idx]);
@@ -173,5 +173,5 @@
 
     // Now process domain and axis
-    CArray<bool,1> axisDomainOrder = grid->axis_domain_order;
+    CArray<int,1> axisDomainOrder = grid->axis_domain_order;
     int numElement = domainP.size() + axisP.size();
     int elementPosition = 0;
@@ -181,5 +181,5 @@
     for (int i = 0; i < numElement; ++i)
     {
-      if(axisDomainOrder(i))
+      if(2 == axisDomainOrder(i))
       {
         if (readAttributeValues)
@@ -197,5 +197,5 @@
         else elementPosition += 2;
       }
-      else
+      else if (1 == axisDomainOrder(i))
       {
         if (readAttributeValues)
